#include <sys/types.h>  /* per fork */
#include <unistd.h>

#include <signal.h>     /* per gestione segnali */

#include <stdio.h>      /* per I/O */

pid_t figlio1,figlio2;

void padreUser1(int segnale) {
  printf("Padre: Ricevuto il segnale: %d \n",segnale);
  kill(figlio2,SIGUSR1);
  printf("Padre: Inviato segnale al II figlio \n");
}

void figlioUser1(int segnale) {
  printf("FIGLIO2: Ricevuto il segnale: %d \n",segnale);
}


int main() {
  int status;
  printf("PADRE: Inizio \n");


  if ((figlio1 = fork()) == -1) {
    perror("PADRE: Impossibile forkare!!!");
    exit(1);
  }

  if (figlio1 > 0) { /* Codice del padre */
    if ((figlio2 = fork()) == -1) {
      perror("PADRE: Impossibile forkare!!!");
      exit(1);
    }
    
    if (figlio2 > 0) { /* Codice del padre */
      signal(SIGUSR1,padreUser1);
      printf("Padre: Entro in pausa\n");
      pause();
      printf("Padre: Attendo la morte del figlio\n");
      wait(&status);
      printf("Terminato un figlio\n");
      wait(&status);
      printf("Terminato un figlio\n");
    }
    else { /* Codice del figlio 2 */
      signal(SIGUSR1,figlioUser1);
      printf("Figlio2: Entro in pausa\n");
      pause();
      exit(0);
    }
  }
  else {/* Codice del figlio1 */
    sleep(10);
    printf("Figlio: invio il segnale SIGUSR1 al padre!\n");
    kill(getppid(),SIGUSR1);
    sleep(5);
    printf("Figlio: FINE!\n");
    exit(0);
  }

}
